describe('setTimeoutのテスト', function() {
  var clock;
  beforeEach(function() {
    //（1）Fake Timerを有効化
    clock = sinon.useFakeTimers();
  });

  afterEach(function() {
    //（2）各テストが終了後にFake Timerを元に戻す
    clock.restore();
  });

  it('100ms後にコールバックが呼ばれる', function() {
    //（3）Spyを作成
    var spy = sinon.spy();

    //（4）コールバックの呼び出しをSpyが記録
    setTimeout(spy, 100);

    //（5）Fake Timerで時間を99ms進める
    clock.tick(99);

    //（6）まだ呼ばれていない
    expect(spy.notCalled).to.ok();

    //（7）時間をさらに1ms進める（合計100ms）
    clock.tick(1);

    //（8）コールバックが同期的に実行された
    expect(spy.called).to.ok();
  });
});
