var expect = require('expect.js');
describe('Array', function() {
  // （1）1つ目のグループ
  describe('要素があるとき', function() {
    var array;
    // （2）各テスト実行前にオブジェクトを初期化
    beforeEach(function() {
      array = ['a', 'b', 'c'];
    });

    it('pop()は最後の要素を取り除いて返す', function() {
      expect(array.pop()).to.be('c');
      expect(array).to.eql(['a', 'b']);
    });

    it('indexOf()は引数と等しい要素のインデックスを返す', function() {
      expect(array.indexOf('c')).to.be(2);
    });
  });

  // （3）2つ目のグループ
  describe('要素が空のとき', function() {
    it('pop()はundefinedを返す', function() {
      expect([].pop()).to.be(undefined);
    });
  });
});
